package com.azt.itower.command;

/**
 *  
 * This class can keep in the future common behaviour between commands
 * It is part of the command hierarchy from the design pattern <B> Command </B>
 * @author thanassis@thanassis.com
 * @version 0.9 beta
 */
public abstract class AbstractCommand implements Command {

    public AbstractCommand() {
    }

    /**
     * any command should be able to execute
     */
    public abstract void execute();

    /**
     * possibly to unexecute for undo functionality
     */
    public abstract void unexecute();
}
