package com.azt.itower.deck;

import java.util.*;
import com.azt.itower.game.GameException;

/**
 *
 * A deck factory initialises and then adds all of its cards to a stack
 * @author thanassis@thanassis.com
 * @version 0.9 beta
 */
public interface DeckFactory {
    /**
     * initialises the Factory
     * @exception GameException
     */
    public void init() throws GameException;

   /**
    * Pushes the cards to the stack
    * @param Stack Fills the Stack with cards
    * @see java.util.Stack
    */
    public void addCards(Stack st);
}
