package com.azt.itower.game;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import com.azt.itower.util.*;

/**
 *
 * This is the view of the two castles. It's a pretty heavy class that needs braking
 * up and serious refactoring
 * @author thanassis@thanassis.com
 * @version 0.9 beta
 */
public class CastlePanel extends Panel implements GameChangeListener, ResourceConstants {
    private Player fPlayer1;
    private Player fPlayer2;
    private Image[] imageArray;
    private Image background;
    private Image wallImage;
    private Image redTowerImage;private Image blueTowerImage;
    private Image imageBuf;
    private Image[] blueWallImageArray;
    private int[] [] blueWallImageOffsets = {{181,335},{174,345},{371,325},{165, 351},{219,310}, { 8,362 } , { 0, 309}};
    private Image[] redWallImageArray;
    private int[] [] redWallImageOffsets = {{466,326},{568,334},{461,316},{561,344},{455,315}, { 635,354 } , { 622, 313}};
    private Image introLogo;
    private Image introLogo2;
    private Image introLogo3;
    private Image introCB, introCR;
    private Image MonoBackground;
    private Image looseImage;
    private Image winImage;
    private Font storedCounterFont;private Font productionCounterFont;
    private float transpCounter = 0.0f;

    /**
     * To crete a Castle Panel we need to pass the two player instances
     * @param Player Player 1
     * @param Player Player 2
     */
    CastlePanel(Player p1, Player p2) {
        fPlayer1 = p1;
        fPlayer2 = p2;
        setBackground(Color.black);
        background = IvoryTower.loadImage(kBACKGROUND_IMG);
        MonoBackground = createImage(
            new FilteredImageSource(background.getSource(),
            new GrayImageFilter()));
        MediaTracker mt = new MediaTracker(this);
        mt.addImage(MonoBackground, 0);
        try {
            mt.waitForAll();
        } catch (Exception ignore) {
        }
        imageArray = new Image[3];
        redWallImageArray = new Image[redWallImageOffsets.length];
        blueWallImageArray = new Image[blueWallImageOffsets.length];
        for (int i = 0; i < imageArray.length; i++) {
            imageArray[i] = IvoryTower.loadImage(kIMAGE_HOME + "production" + i + ".jpg");
        }
        for (int i = 0; i < redWallImageArray.length; i++) {
            redWallImageArray[i] = IvoryTower.loadImage(kIMAGE_HOME + "redWall" + (i + 1) + ".gif");
        }
        for (int i = 0; i < blueWallImageArray.length; i++) {
            blueWallImageArray[i] = IvoryTower.loadImage(kIMAGE_HOME + "blueWall" + (i + 1) + ".gif");
        }
        wallImage = IvoryTower.loadImage(kWALL_IMG);
        introLogo = IvoryTower.loadImage(kINTRO_LOGO);
        introLogo2 = IvoryTower.loadImage(kINTRO_LOGO2);
        introLogo3 = IvoryTower.loadImage(kINTRO_LOGO3);
        introCB = IvoryTower.loadImage(kINTRO_CBLUE);
        introCR = IvoryTower.loadImage(kINTRO_CRED);
        blueTowerImage = IvoryTower.loadImage(kTOWERA_IMG);
        redTowerImage = IvoryTower.loadImage(kTOWERB_IMG);
        looseImage = IvoryTower.loadImage(kLOOSE_IMG);
        winImage = IvoryTower.loadImage(kWIN_IMG);
        storedCounterFont = new Font("Helvetica", Font.BOLD, 24);
        productionCounterFont = new Font("Helvetica", Font.PLAIN, 12);
        imageBuf = createImage(783, 504);
    }

    /**
     * Sets the players
     * @param Player Player 1
     * @param Player Player 2
     */
    public void setPlayers(Player p1, Player p2) {
        fPlayer1 = p1;
        fPlayer2 = p2;
    }



    /**
     * Increases the transparency of the background image
     */
    public void increaseBackColour() {
        transpCounter = transpCounter + 0.1f;
        MonoBackground = createImage(
            new FilteredImageSource(MonoBackground.getSource(),
            new TransparentImageFilter(transpCounter)));
        MediaTracker mt = new MediaTracker(this);
        mt.addImage(MonoBackground, 0);
        try {
            mt.waitForAll();
        } catch (Exception ignore) {
        }
    }

    /**
     * Notifies that the state has changed
     */
    public void stateChanged() {
        repaint();
    }

    /**
     * Paints the Castle Panel by delegating the call depending on the
     * state of the game
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
    public void paint(Graphics g) {
        if (IvoryTower.GameState == IvoryTower.kGAME_STATE_PLAYING)
            paintGame(g);
        else if (IvoryTower.GameState == IvoryTower.kGAME_STATE_INTRO)
            paintIntro(g);
        else if (IvoryTower.GameState == IvoryTower.kGAME_STATE_STARTING)
            paintStart(g);
        else if (IvoryTower.GameState == IvoryTower.kGAME_STATE_WIN)
            paintWin(g);
        else if (IvoryTower.GameState == IvoryTower.kGAME_STATE_LOOSE)
            paintLoose(g);
    }

    /**
     * This gives us a chance to play a quick animation for the intro
     */
    public void playIntro() {
      /*
      Thread t = new Thread{

        public void run() {
        int y = 20;
        while(y>300);
          pause(3);
          y=y+5;
        }
      };
      t.start();
      */
    }

    /**
     * Paints the start of the game after the animation
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
    public void paintStart(Graphics g) {
        imageBuf = createImage(783, 504);
        Graphics Grbuffer = imageBuf.getGraphics();
        if (MonoBackground != null) {
            Grbuffer.drawImage(MonoBackground, 0, 0, this);
            g.drawImage(imageBuf, 0, 0, this);
        }
    }

    /**
     * Paints the intro screen that allows the player to start
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
    public void paintIntro(Graphics g) {
        imageBuf = createImage(783, 504);
        Graphics Grbuffer = imageBuf.getGraphics();
        if (MonoBackground != null) {
            Grbuffer.drawImage(MonoBackground, 0, 0, this);
            Grbuffer.drawImage(introLogo3, 225, 175, this);
            Grbuffer.drawImage(introCB, 35, 139, this);
            Grbuffer.drawImage(introCR, 540, 139, this);
            Grbuffer.drawImage(introLogo, 120, 18, this);
            Grbuffer.drawImage(introLogo2, 340, 135, this);


        }
        Grbuffer.setColor(Color.white);
        Grbuffer.drawString("Press 'S' to start ", 355, 395);
        Grbuffer.drawString("Press 'H' for help", 355, 415);

        g.drawImage(imageBuf, 0, 0, this);
    }


    /**
     * pauses for mil milliseconds
     * @param int Milliseconds of pause
     */
    public void pause(int mil) {
        try {
            Thread.currentThread().sleep(mil);
        } catch (Exception ex) {
        }
    }

    /**
     * Paints the winning sequence
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
    public void paintWin(Graphics g) {
        g.setColor(Color.green);
        g.drawImage(winImage, 200, 100, this);
        g.drawString("Player 1 has won", 50, 50);
    }

    /**
     * Paints the loosing sequence
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
    public void paintLoose(Graphics g) {
        g.setColor(Color.blue);
        g.drawImage(looseImage, 260, 160, this);
        //g.drawString("Player 1 has lost!", 50, 50);
    }


    /**
     * Paints the game as it progresses
     * Delegates the calls to smaller helper painting methods
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
    public void paintGame(Graphics g) {

        Graphics Grbuffer = imageBuf.getGraphics();
        paintBackground(Grbuffer);
        paintDeck(Grbuffer);
        paintPlayer1Castle(Grbuffer);
        paintPlayer2Castle(Grbuffer);
        paintPlayerData(Grbuffer, fPlayer1, 20, 80);
        paintPlayerData(Grbuffer, fPlayer2, 685, 80);
        g.drawImage(imageBuf, 0, 0, this);
    }


    /**
     * This awt method needs overiding for double buffering
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
    public void update(Graphics g) {
        paint(g);
    }

    /**
     * Paints the last two cards that were played
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
    private void paintDeck(Graphics g) {
        Card[] c = DeckManager.getInstance().peekTwoCards();

        if (c[0] != null) {
            c[0].setOrigin(
                new Point(600 / 2 - 44, 100 - 88));
            c[0].paintAsDeck(g, this);
        }
        if (c[1] != null) {
            c[1].setOrigin(
                new Point(800 / 2 - 44, 100 - 88));
            c[1].paintAsDeck(g, this);
        }

    }

    /**
     * Paints the castle of the first player
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
    public void paintPlayer1Castle(Graphics g) {
        int towersize = (int)(fPlayer1.getTowerSize());
        int wallsize = (int)(fPlayer1.getWallSize());
        paintPlayer1Wall(g, wallsize);
        g.setColor(Color.white);
        g.setFont(productionCounterFont);
        g.setColor(Color.cyan);
        g.drawString("" + fPlayer1.getTowerSize(), 130, 270 - towersize + 117);
        g.setColor(Color.white);
        g.drawString("" + fPlayer1.getWallSize(), 325, 430);
    }

    /**
     * Paints the tower of the first player
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
     public void paintPlayer1Tower(Graphics g) {
        int towersize = (int)(fPlayer1.getTowerSize());
        int h = blueTowerImage.getHeight(this);
        int step = Math.round(h / 100); // 200 is the maximum tower size
        int sizeY = towersize * step;
        if (sizeY <= 0) sizeY = 1;
        Image clippedBuf = createImage(blueTowerImage.getWidth(this), sizeY);
        Graphics Grbuffer = clippedBuf.getGraphics();
        Grbuffer.drawImage(imageBuf, -35, -(139 + h - sizeY), this);
        Grbuffer.drawImage(blueTowerImage, 0, 0, this);
        g.drawImage(clippedBuf, 35, 139 + h - sizeY, blueTowerImage.getWidth(this), sizeY, this);
    }

    /**
     * Paints the tower of the second player
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
    public void paintPlayer2Tower(Graphics g) {
        int towersize = (int)(fPlayer2.getTowerSize());
        int h = redTowerImage.getHeight(this);
        int step = Math.round(h / 100); // 200 is the maximum tower size
        int sizeY = towersize * step;
        if (sizeY <= 0) sizeY = 1;
        Image clippedBuf = createImage(redTowerImage.getWidth(this), sizeY);
        Graphics Grbuffer = clippedBuf.getGraphics();
        Grbuffer.drawImage(imageBuf, -540, -(139 + h - sizeY), this);
        Grbuffer.drawImage(redTowerImage, 0, 0, this);
        //gg.clipRect(0,0,redTowerImage.getWidth(this), sizeY);
        g.drawImage(clippedBuf, 540, 139 + h - sizeY, this);
    }

    /**
     * Paints the wall of the first player
     * This is a simple but large method that paints each one of the walls
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
    public void paintPlayer1Wall(Graphics g, int wallsize) {
        int kSTEP = 13;
        int counter = 0;
        int remainder = wallsize % kSTEP;
        int div = wallsize / kSTEP;
        int stepY;
        int dx = 0; int dy = 0;
        //paint the current wall if its behind other walls
        if ((div <= 6) && (div % 2 == 0)) {
            dx = blueWallImageArray[div].getWidth(this);
            dy = blueWallImageArray[div].getHeight(this);
            stepY = (dy / kSTEP); // height in pixel per model point
            int dtr = remainder * stepY;
            int dl = dy - dtr;
            //System.out.println("========= >>> > >> >> > dy : " + dy + " dl : " + dl + " dtr : " + dtr);
            g.drawImage(blueWallImageArray[div], blueWallImageOffsets[div] [0], (blueWallImageOffsets[div] [1] + dl), dx, dtr, this);
        }
        switch (div) {
            case 0:
                paintPlayer1Tower(g);
                break;
            case 1:
                paintPlayer1Tower(g);
                g.drawImage(blueWallImageArray[0], blueWallImageOffsets[0] [0], blueWallImageOffsets[0] [1], blueWallImageArray[0].getWidth(this),
                    blueWallImageArray[0].getHeight(this), this);
                break;
            case 2:
                paintPlayer1Tower(g);
                g.drawImage(blueWallImageArray[0], blueWallImageOffsets[0] [0], blueWallImageOffsets[0] [1], blueWallImageArray[0].getWidth(this),
                    blueWallImageArray[0].getHeight(this), this);
                g.drawImage(blueWallImageArray[1], blueWallImageOffsets[1] [0], blueWallImageOffsets[1] [1], blueWallImageArray[1].getWidth(this),
                    blueWallImageArray[1].getHeight(this), this);
                break;
            case 3:
                g.drawImage(blueWallImageArray[2], blueWallImageOffsets[2] [0], blueWallImageOffsets[2] [1], blueWallImageArray[2].getWidth(this),
                    blueWallImageArray[2].getHeight(this), this);
                paintPlayer1Tower(g);
                g.drawImage(blueWallImageArray[0], blueWallImageOffsets[0] [0], blueWallImageOffsets[0] [1], blueWallImageArray[0].getWidth(this),
                    blueWallImageArray[0].getHeight(this), this);
                g.drawImage(blueWallImageArray[1], blueWallImageOffsets[1] [0], blueWallImageOffsets[1] [1], blueWallImageArray[1].getWidth(this),
                    blueWallImageArray[1].getHeight(this), this);
                break;
            case 4:
                g.drawImage(blueWallImageArray[2], blueWallImageOffsets[2] [0], blueWallImageOffsets[2] [1], blueWallImageArray[2].getWidth(this),
                    blueWallImageArray[2].getHeight(this), this);
                paintPlayer1Tower(g);
                g.drawImage(blueWallImageArray[0], blueWallImageOffsets[0] [0], blueWallImageOffsets[0] [1], blueWallImageArray[0].getWidth(this),
                    blueWallImageArray[0].getHeight(this), this);
                g.drawImage(blueWallImageArray[1], blueWallImageOffsets[1] [0], blueWallImageOffsets[1] [1], blueWallImageArray[1].getWidth(this),
                    blueWallImageArray[1].getHeight(this), this);
                g.drawImage(blueWallImageArray[3], blueWallImageOffsets[3] [0], blueWallImageOffsets[3] [1], blueWallImageArray[3].getWidth(this),
                    blueWallImageArray[3].getHeight(this), this);
                break;
            case 5:
                g.drawImage(blueWallImageArray[4], blueWallImageOffsets[4] [0], blueWallImageOffsets[4] [1], blueWallImageArray[4].getWidth(this),
                    blueWallImageArray[4].getHeight(this), this);
                g.drawImage(blueWallImageArray[2], blueWallImageOffsets[2] [0], blueWallImageOffsets[2] [1], blueWallImageArray[2].getWidth(this),
                    blueWallImageArray[2].getHeight(this), this);
                paintPlayer1Tower(g);
                g.drawImage(blueWallImageArray[0], blueWallImageOffsets[0] [0], blueWallImageOffsets[0] [1], blueWallImageArray[0].getWidth(this),
                    blueWallImageArray[0].getHeight(this), this);
                g.drawImage(blueWallImageArray[1], blueWallImageOffsets[1] [0], blueWallImageOffsets[1] [1], blueWallImageArray[1].getWidth(this),
                    blueWallImageArray[1].getHeight(this), this);
                g.drawImage(blueWallImageArray[3], blueWallImageOffsets[3] [0], blueWallImageOffsets[3] [1], blueWallImageArray[3].getWidth(this),
                    blueWallImageArray[3].getHeight(this), this);
                break;
            case 6:
                g.drawImage(blueWallImageArray[4], blueWallImageOffsets[4] [0], blueWallImageOffsets[4] [1], blueWallImageArray[4].getWidth(this),
                    blueWallImageArray[4].getHeight(this), this);
                g.drawImage(blueWallImageArray[2], blueWallImageOffsets[2] [0], blueWallImageOffsets[2] [1], blueWallImageArray[2].getWidth(this),
                    blueWallImageArray[2].getHeight(this), this);
                paintPlayer1Tower(g);
                g.drawImage(blueWallImageArray[0], blueWallImageOffsets[0] [0], blueWallImageOffsets[0] [1], blueWallImageArray[0].getWidth(this),
                    blueWallImageArray[0].getHeight(this), this);
                g.drawImage(blueWallImageArray[1], blueWallImageOffsets[1] [0], blueWallImageOffsets[1] [1], blueWallImageArray[1].getWidth(this),
                    blueWallImageArray[1].getHeight(this), this);
                g.drawImage(blueWallImageArray[3], blueWallImageOffsets[3] [0], blueWallImageOffsets[3] [1], blueWallImageArray[3].getWidth(this),
                    blueWallImageArray[3].getHeight(this), this);
                g.drawImage(blueWallImageArray[5], blueWallImageOffsets[5] [0], blueWallImageOffsets[5] [1], blueWallImageArray[5].getWidth(this),
                    blueWallImageArray[5].getHeight(this), this);
                break;
            case 7:
                g.drawImage(blueWallImageArray[6], blueWallImageOffsets[6] [0], blueWallImageOffsets[6] [1], blueWallImageArray[6].getWidth(this),
                    blueWallImageArray[6].getHeight(this), this);
                g.drawImage(blueWallImageArray[4], blueWallImageOffsets[4] [0], blueWallImageOffsets[4] [1], blueWallImageArray[4].getWidth(this),
                    blueWallImageArray[4].getHeight(this), this);
                g.drawImage(blueWallImageArray[2], blueWallImageOffsets[2] [0], blueWallImageOffsets[2] [1], blueWallImageArray[2].getWidth(this),
                    blueWallImageArray[2].getHeight(this), this);
                paintPlayer1Tower(g);
                g.drawImage(blueWallImageArray[0], blueWallImageOffsets[0] [0], blueWallImageOffsets[0] [1], blueWallImageArray[0].getWidth(this),
                    blueWallImageArray[0].getHeight(this), this);
                g.drawImage(blueWallImageArray[1], blueWallImageOffsets[1] [0], blueWallImageOffsets[1] [1], blueWallImageArray[1].getWidth(this),
                    blueWallImageArray[1].getHeight(this), this);
                g.drawImage(blueWallImageArray[3], blueWallImageOffsets[3] [0], blueWallImageOffsets[3] [1], blueWallImageArray[3].getWidth(this),
                    blueWallImageArray[3].getHeight(this), this);
                g.drawImage(blueWallImageArray[5], blueWallImageOffsets[5] [0], blueWallImageOffsets[5] [1], blueWallImageArray[5].getWidth(this),
                    blueWallImageArray[5].getHeight(this), this);
                break;
            default:
                g.drawImage(blueWallImageArray[6], blueWallImageOffsets[6] [0], blueWallImageOffsets[6] [1], blueWallImageArray[6].getWidth(this),
                    blueWallImageArray[6].getHeight(this), this);
                g.drawImage(blueWallImageArray[4], blueWallImageOffsets[4] [0], blueWallImageOffsets[4] [1], blueWallImageArray[4].getWidth(this),
                    blueWallImageArray[4].getHeight(this), this);
                g.drawImage(blueWallImageArray[2], blueWallImageOffsets[2] [0], blueWallImageOffsets[2] [1], blueWallImageArray[2].getWidth(this),
                    blueWallImageArray[2].getHeight(this), this);
                paintPlayer1Tower(g);
                g.drawImage(blueWallImageArray[0], blueWallImageOffsets[0] [0], blueWallImageOffsets[0] [1], blueWallImageArray[0].getWidth(this),
                    blueWallImageArray[0].getHeight(this), this);
                g.drawImage(blueWallImageArray[1], blueWallImageOffsets[1] [0], blueWallImageOffsets[1] [1], blueWallImageArray[1].getWidth(this),
                    blueWallImageArray[1].getHeight(this), this);
                g.drawImage(blueWallImageArray[3], blueWallImageOffsets[3] [0], blueWallImageOffsets[3] [1], blueWallImageArray[3].getWidth(this),
                    blueWallImageArray[3].getHeight(this), this);
                g.drawImage(blueWallImageArray[5], blueWallImageOffsets[5] [0], blueWallImageOffsets[5] [1], blueWallImageArray[4].getWidth(this),
                    blueWallImageArray[4].getHeight(this), this);
                break;
        }
        if ((div <= 6) && ((div % 2 != 0) || (div == 0))) {
            dx = blueWallImageArray[div].getWidth(this);
            dy = blueWallImageArray[div].getHeight(this);
            stepY = (dy / kSTEP); // height in pixel per model point
            int dtr = remainder * stepY;
            int dl = dy - dtr;
            //System.out.println("========= >>> > >> >> > dy : " + dy + " dl : " + dl + " dtr : " + dtr);
            g.drawImage(blueWallImageArray[div], blueWallImageOffsets[div] [0], (blueWallImageOffsets[div] [1] + dl), dx, dtr, this);
        }

    }

    /**
     * Paints the castle of the second player
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
    public void paintPlayer2Castle(Graphics g) {
        int towersize = (int)(fPlayer2.getTowerSize());
        int wallsize = (int)(fPlayer2.getWallSize());
        paintPlayer2Wall(g, wallsize);
        //g.drawImage(wallImage, 230, 363 - wallsize, wallsize/2, wallsize, this);
        //g.drawImage(capAImage, 140, 275 - towersize,  this);
        g.setFont(productionCounterFont);
        g.setColor(Color.red);
        g.drawString("" + fPlayer2.getTowerSize(), 620, 275 - towersize + 117);
        g.setColor(Color.white);
        g.drawString("" + fPlayer2.getWallSize(), 490, 410);
    }

    /**
     * Paints the wall of the second player
     * This is a simple but large method that paints each one of the walls
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
    public void paintPlayer2Wall(Graphics g, int wallsize) {
        int kSTEP = 13;
        int counter = 0;
        int remainder = wallsize % kSTEP;
        int div = wallsize / kSTEP;
        int stepY;
        int dx = 0; int dy = 0;
        //paint the current wall if its behind other walls
        if ((div <= 6) && (div % 2 == 0)) {
            dx = redWallImageArray[div].getWidth(this);
            dy = redWallImageArray[div].getHeight(this);
            stepY = (dy / kSTEP); // height in pixel per model point
            int dtr = remainder * stepY;
            int dl = dy - dtr;
            //System.out.println("========= >>> > >> >> > dy : " + dy + " dl : " + dl + " dtr : " + dtr);
            g.drawImage(redWallImageArray[div], redWallImageOffsets[div] [0], (redWallImageOffsets[div] [1] + dl), dx, dtr, this);
        }
        switch (div) {
            case 0:
                paintPlayer2Tower(g);
                break;
            case 1:
                paintPlayer2Tower(g);
                g.drawImage(redWallImageArray[0], redWallImageOffsets[0] [0], redWallImageOffsets[0] [1], redWallImageArray[0].getWidth(this),
                    redWallImageArray[0].getHeight(this), this);
                break;
            case 2:
                paintPlayer2Tower(g);
                g.drawImage(redWallImageArray[0], redWallImageOffsets[0] [0], redWallImageOffsets[0] [1], redWallImageArray[0].getWidth(this),
                    redWallImageArray[0].getHeight(this), this);
                g.drawImage(redWallImageArray[1], redWallImageOffsets[1] [0], redWallImageOffsets[1] [1], redWallImageArray[1].getWidth(this),
                    redWallImageArray[1].getHeight(this), this);
                break;
            case 3:
                g.drawImage(redWallImageArray[2], redWallImageOffsets[2] [0], redWallImageOffsets[2] [1], redWallImageArray[2].getWidth(this),
                    redWallImageArray[2].getHeight(this), this);
                paintPlayer2Tower(g);
                g.drawImage(redWallImageArray[0], redWallImageOffsets[0] [0], redWallImageOffsets[0] [1], redWallImageArray[0].getWidth(this),
                    redWallImageArray[0].getHeight(this), this);
                g.drawImage(redWallImageArray[1], redWallImageOffsets[1] [0], redWallImageOffsets[1] [1], redWallImageArray[1].getWidth(this),
                    redWallImageArray[1].getHeight(this), this);
                break;
            case 4:
                g.drawImage(redWallImageArray[2], redWallImageOffsets[2] [0], redWallImageOffsets[2] [1], redWallImageArray[2].getWidth(this),
                    redWallImageArray[2].getHeight(this), this);
                paintPlayer2Tower(g);
                g.drawImage(redWallImageArray[0], redWallImageOffsets[0] [0], redWallImageOffsets[0] [1], redWallImageArray[0].getWidth(this),
                    redWallImageArray[0].getHeight(this), this);
                g.drawImage(redWallImageArray[1], redWallImageOffsets[1] [0], redWallImageOffsets[1] [1], redWallImageArray[1].getWidth(this),
                    redWallImageArray[1].getHeight(this), this);
                g.drawImage(redWallImageArray[3], redWallImageOffsets[3] [0], redWallImageOffsets[3] [1], redWallImageArray[3].getWidth(this),
                    redWallImageArray[3].getHeight(this), this);
                break;
            case 5:
                g.drawImage(redWallImageArray[4], redWallImageOffsets[4] [0], redWallImageOffsets[4] [1], redWallImageArray[4].getWidth(this),
                    redWallImageArray[4].getHeight(this), this);
                g.drawImage(redWallImageArray[2], redWallImageOffsets[2] [0], redWallImageOffsets[2] [1], redWallImageArray[2].getWidth(this),
                    redWallImageArray[2].getHeight(this), this);
                paintPlayer2Tower(g);
                g.drawImage(redWallImageArray[0], redWallImageOffsets[0] [0], redWallImageOffsets[0] [1], redWallImageArray[0].getWidth(this),
                    redWallImageArray[0].getHeight(this), this);
                g.drawImage(redWallImageArray[1], redWallImageOffsets[1] [0], redWallImageOffsets[1] [1], redWallImageArray[1].getWidth(this),
                    redWallImageArray[1].getHeight(this), this);
                g.drawImage(redWallImageArray[3], redWallImageOffsets[3] [0], redWallImageOffsets[3] [1], redWallImageArray[3].getWidth(this),
                    redWallImageArray[3].getHeight(this), this);
                break;
            case 6:
                g.drawImage(redWallImageArray[4], redWallImageOffsets[4] [0], redWallImageOffsets[4] [1], redWallImageArray[4].getWidth(this),
                    redWallImageArray[4].getHeight(this), this);
                g.drawImage(redWallImageArray[2], redWallImageOffsets[2] [0], redWallImageOffsets[2] [1], redWallImageArray[2].getWidth(this),
                    redWallImageArray[2].getHeight(this), this);
                paintPlayer2Tower(g);
                g.drawImage(redWallImageArray[0], redWallImageOffsets[0] [0], redWallImageOffsets[0] [1], redWallImageArray[0].getWidth(this),
                    redWallImageArray[0].getHeight(this), this);
                g.drawImage(redWallImageArray[1], redWallImageOffsets[1] [0], redWallImageOffsets[1] [1], redWallImageArray[1].getWidth(this),
                    redWallImageArray[1].getHeight(this), this);
                g.drawImage(redWallImageArray[3], redWallImageOffsets[3] [0], redWallImageOffsets[3] [1], redWallImageArray[3].getWidth(this),
                    redWallImageArray[3].getHeight(this), this);
                g.drawImage(redWallImageArray[5], redWallImageOffsets[5] [0], redWallImageOffsets[5] [1], redWallImageArray[5].getWidth(this),
                    redWallImageArray[5].getHeight(this), this);
                break;
            case 7:
                g.drawImage(redWallImageArray[6], redWallImageOffsets[6] [0], redWallImageOffsets[6] [1], redWallImageArray[6].getWidth(this),
                    redWallImageArray[6].getHeight(this), this);
                g.drawImage(redWallImageArray[4], redWallImageOffsets[4] [0], redWallImageOffsets[4] [1], redWallImageArray[4].getWidth(this),
                    redWallImageArray[4].getHeight(this), this);
                g.drawImage(redWallImageArray[2], redWallImageOffsets[2] [0], redWallImageOffsets[2] [1], redWallImageArray[2].getWidth(this),
                    redWallImageArray[2].getHeight(this), this);
                paintPlayer2Tower(g);
                g.drawImage(redWallImageArray[0], redWallImageOffsets[0] [0], redWallImageOffsets[0] [1], redWallImageArray[0].getWidth(this),
                    redWallImageArray[0].getHeight(this), this);
                g.drawImage(redWallImageArray[1], redWallImageOffsets[1] [0], redWallImageOffsets[1] [1], redWallImageArray[1].getWidth(this),
                    redWallImageArray[1].getHeight(this), this);
                g.drawImage(redWallImageArray[3], redWallImageOffsets[3] [0], redWallImageOffsets[3] [1], redWallImageArray[3].getWidth(this),
                    redWallImageArray[3].getHeight(this), this);
                g.drawImage(redWallImageArray[5], redWallImageOffsets[5] [0], redWallImageOffsets[5] [1], redWallImageArray[5].getWidth(this),
                    redWallImageArray[5].getHeight(this), this);
                break;
            default:
                g.drawImage(redWallImageArray[6], redWallImageOffsets[6] [0], redWallImageOffsets[6] [1], redWallImageArray[6].getWidth(this),
                    redWallImageArray[6].getHeight(this), this);
                g.drawImage(redWallImageArray[4], redWallImageOffsets[4] [0], redWallImageOffsets[4] [1], redWallImageArray[4].getWidth(this),
                    redWallImageArray[4].getHeight(this), this);
                g.drawImage(redWallImageArray[2], redWallImageOffsets[2] [0], redWallImageOffsets[2] [1], redWallImageArray[2].getWidth(this),
                    redWallImageArray[2].getHeight(this), this);
                paintPlayer2Tower(g);
                g.drawImage(redWallImageArray[0], redWallImageOffsets[0] [0], redWallImageOffsets[0] [1], redWallImageArray[0].getWidth(this),
                    redWallImageArray[0].getHeight(this), this);
                g.drawImage(redWallImageArray[1], redWallImageOffsets[1] [0], redWallImageOffsets[1] [1], redWallImageArray[1].getWidth(this),
                    redWallImageArray[1].getHeight(this), this);
                g.drawImage(redWallImageArray[3], redWallImageOffsets[3] [0], redWallImageOffsets[3] [1], redWallImageArray[3].getWidth(this),
                    redWallImageArray[3].getHeight(this), this);
                g.drawImage(redWallImageArray[5], redWallImageOffsets[5] [0], redWallImageOffsets[5] [1], redWallImageArray[4].getWidth(this),
                    redWallImageArray[4].getHeight(this), this);
                break;
        }
        if ((div <= 6) && ((div % 2 != 0) || (div == 0))) {
            dx = redWallImageArray[div].getWidth(this);
            dy = redWallImageArray[div].getHeight(this);
            stepY = (dy / kSTEP); // height in pixel per model point
            int dtr = remainder * stepY;
            int dl = dy - dtr;
            //System.out.println("========= >>> > >> >> > dy : " + dy + " dl : " + dl + " dtr : " + dtr);
            g.drawImage(redWallImageArray[div], redWallImageOffsets[div] [0], (redWallImageOffsets[div] [1] + dl), dx, dtr, this);
        }

    }

    /**
     * Paints the background picture
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
    public void paintBackground(Graphics g) {
        int xoff = 0;
        int yoff = 0;
        g.drawImage(background, xoff, yoff, this);
    }

    /**
     * Paints the resources data of the two players
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
    public void paintPlayerData(Graphics g, Player player, int xoff, int yoff) {
        int[] storedArr = new int[3];
        int[] productionArr = new int[3];
        storedArr[0] = player.getStones();
        storedArr[1] = player.getGems();
        storedArr[2] = player.getMonsters();
        productionArr[0] = player.getStoneProduction();
        productionArr[1] = player.getGemProduction();
        productionArr[2] = player.getMonsterProduction();
        for (int i = 0; i < imageArray.length; i++) {
            g.drawImage(imageArray[i], xoff, yoff * (i + 1), this);
            g.setFont(productionCounterFont);
            g.drawString(player.getName(), xoff, yoff - 60);
            if (IvoryTower.currentPlayer == player) {
                g.setColor(Color.green);
                g.drawRect(xoff - 5, yoff - 73, 100, 20);
            }
            g.setColor(Color.darkGray);
            g.drawString("" + (storedArr[i]), 18 + xoff, 68 + yoff * (i + 1));
            g.setColor(Color.white);
            g.setFont(storedCounterFont);
            g.drawString("" + productionArr[i], 7 + xoff, 25 + yoff * (i + 1));
        }
    }

    /**
     * Paints the resource images of the second player
     * @param Graphics AWT's Graphics Context
     * @see java.awt.Graphics
     */
    public void paintPlayer2(Graphics g) {
        int xoff = 500;
        int yoff = 80;
        for (int i = 0; i < imageArray.length; i++) {
            g.drawImage(imageArray[i], xoff, yoff * (i + 1), this);
        }
    }

    /**
     * Returns the preferred size of the Castle Panel
     * @return Dimension
     * @see java.awt.Dimension
     * @see java.awt.Component.getPreferredSize()
     */
    public Dimension getPreferredSize() {
        return new Dimension(780, 550);
    }
}

