package com.azt.itower.game;

/**
 *
 * Simple Strategy Interface to define the rules of wining and loosing
 * @author thanassis@thanassis.com
 * @version 0.9 beta
 */
public interface GameCondition {

    /**
     * Providing a Player it returns a boolean indicating
     * whether the winning condition has been satisfied
     * @param Player The player that needs to know
     * @return boolean The result of the checking of the winning
     * condition rules
     */
    public boolean checkWinCondition(Player p);

    /**
     * Providing a Player it returns a boolean indicating
     * whether the loosing condition has been satisfied
     * @param Player The player that needs to know
     * @return boolean The result of the checking of the loosing
     * condition rules
     */
    public boolean checkLoseCondition(Player p);
}
