package com.azt.itower.game;

/**
 * Title:
 * Standard implementation defining the rules of wining and loosing
 * @author thanassis@thanassis.com
 * @version 0.9 beta
 */
public class StandardGameCondition implements GameCondition {

    /**
     * Instantiates a StandardGameCondition
     */
    public StandardGameCondition() {
    }

    /**
     * Providing a Player it returns a boolean indicating
     * whether the winning condition has been satisfied
     * @param Player The player upon which the winning checking will take place
     * @return boolean The result of the winning checking
     */
    public boolean checkWinCondition(Player p) {
        return (p.getTowerSize() > 130);
    }

    /**
     * Providing a Player it returns a boolean indicating
     * whether the loosing condition has been satisfied
     * @param Player The player upon which the loosing checking will take place
     * @return boolean The result of the loosing checking
     */
     public boolean checkLoseCondition(Player p) {
        return (p.getTowerSize() < 1);
    }

}
