package com.azt.itower.util;

import java.awt.image.*;

/**
 * Title:
 * An Image Filter that greys-out any awt image
 * @author thanassis@thanassis.com
 * @version 0.9 beta
 */
public class GrayImageFilter extends RGBImageFilter {

    public GrayImageFilter() {
        canFilterIndexColorModel = true;
    }

    /**
     *
     */
    public int filterRGB(int x, int y, int rgb) {
        int gray = (((rgb & 0xff0000) >> 16) + ((rgb & 0x00ff00) >> 8) + (rgb & 0x0000ff)) / 3;
        return (0xff000000 | (gray << 16) | (gray << 8) | gray);
    }
}
