package com.azt.itower.util;

import java.awt.image.*;

/**
 * Title:
 * A Transparency image filter for awt images
 * @author thanassis@thanassis.com
 * @version 0.9 beta
 */
public class TransparentImageFilter extends RGBImageFilter {
    float alphaPercent;

    /**
     * Standard constructor for filters
     * @see java.awt.image
     * @see java.awt.image.RGBImageFilter
     */
    public TransparentImageFilter(float a) throws IllegalArgumentException {
        if ((a < 0.0) || (a > 1.0))
            throw new IllegalArgumentException();
        alphaPercent = a;
        canFilterIndexColorModel = true;
    }

    /**
     * Standard method to overide for awt Filters
     * @see java.awt.image
     * @see java.awt.image.RGBImageFilter
     */
    public int filterRGB(int x, int y, int rgb) {
        int a = (rgb >> 24) & 0xff;
        a *= alphaPercent;
        return ((rgb & 0x00ffffff) | (a << 24));
    }
}
